/*
 * Copyright (c) 2012, Freescale Semiconductor, Inc.
 * All rights reserved.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

// File: usdhc_iomux_config.c

/* ------------------------------------------------------------------------------
 * <auto-generated>
 *     This code was generated by a tool.
 *     Runtime Version:3.4.0.0
 *
 *     Changes to this file may cause incorrect behavior and will be lost if
 *     the code is regenerated.
 * </auto-generated>
 * ------------------------------------------------------------------------------
*/

#include "iomux_config.h"
#include "registers/regsiomuxc.h"
#include "registers/regsusdhc.h"
#include "io.h"
#include <assert.h>


static void usdhc4_iomux_config()
{
    HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CLK_WR     (0x00000000);
    HW_IOMUXC_SW_MUX_CTL_PAD_SD4_CMD_WR     (0x00000010);
    HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA0_WR   (0x00000001);
    HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA1_WR   (0x00000001);
    HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA2_WR   (0x00000001);
    HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA3_WR   (0x00000001);
    HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA4_WR   (0x00000001);
    HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA5_WR   (0x00000001);
    HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA6_WR   (0x00000001);
    HW_IOMUXC_SW_MUX_CTL_PAD_SD4_DATA7_WR   (0x00000001);
    HW_IOMUXC_SW_MUX_CTL_PAD_NAND_ALE_WR    (0x00000001);

    HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CLK_WR(0x00017099);
    HW_IOMUXC_SW_PAD_CTL_PAD_SD4_CMD_WR(0x00017099);
    HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA0_WR(0x00017099);
    HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA1_WR(0x00017099);
    HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA2_WR(0x00017099);
    HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA3_WR(0x00017099);
    HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA4_WR(0x00017099);
    HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA5_WR(0x00017099);
    HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA6_WR(0x00017099);
    HW_IOMUXC_SW_PAD_CTL_PAD_SD4_DATA7_WR(0x00017099);
    HW_IOMUXC_SW_PAD_CTL_PAD_NAND_ALE_WR(0x00017099);

}


static void usdhc2_iomux_config()
{
    HW_IOMUXC_SW_MUX_CTL_PAD_GPIO04_WR      (0x00000006);
    HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CLK_WR     (0x00000000);
    HW_IOMUXC_SW_MUX_CTL_PAD_SD2_CMD_WR     (0x00000010);
    HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA3_WR   (0x00000000);
    HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA2_WR   (0x00000000);
    HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA1_WR   (0x00000000);
    HW_IOMUXC_SW_MUX_CTL_PAD_SD2_DATA0_WR   (0x00000000);
    HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA04_WR (0x00000001);
    HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA05_WR (0x00000001);
    HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA06_WR (0x00000001);
    HW_IOMUXC_SW_MUX_CTL_PAD_NAND_DATA07_WR (0x00000001);

    HW_IOMUXC_SW_PAD_CTL_PAD_GPIO04_WR      (0x00017099);
    HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CLK_WR     (0x00017099);
    HW_IOMUXC_SW_PAD_CTL_PAD_SD2_CMD_WR     (0x00017099);
    HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA3_WR   (0x00017099);
    HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA2_WR   (0x00017099);
    HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA1_WR   (0x00017099);
    HW_IOMUXC_SW_PAD_CTL_PAD_SD2_DATA0_WR   (0x00017099);
    HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA04_WR (0x00017099);
    HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA05_WR (0x00017099);
    HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA06_WR (0x00017099);
    HW_IOMUXC_SW_PAD_CTL_PAD_NAND_DATA07_WR (0x00017099);

}

static void usdhc3_iomux_config()
{
    HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CMD_WR     (0x00000010);
    HW_IOMUXC_SW_MUX_CTL_PAD_SD3_CLK_WR     (0x00000000);
    HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA0_WR   (0x00000000);
    HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA1_WR   (0x00000000);
    HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA2_WR   (0x00000000);
    HW_IOMUXC_SW_MUX_CTL_PAD_SD3_DATA3_WR   (0x00000000);


    HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CMD_WR     (0x00017099);
    HW_IOMUXC_SW_PAD_CTL_PAD_SD3_CLK_WR     (0x00017099);
    HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA0_WR   (0x00017099);
    HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA1_WR   (0x00017099);
    HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA2_WR   (0x00017099);
    HW_IOMUXC_SW_PAD_CTL_PAD_SD3_DATA3_WR   (0x00017099);
}

void usdhc_iomux_config(int instance)
{
    switch (instance)
    {
        case HW_USDHC2:
            return usdhc2_iomux_config();
        case HW_USDHC3:
            return usdhc3_iomux_config();
        case HW_USDHC4:
            return usdhc4_iomux_config();

        default:
            assert(0);
    }
}

